# Usage


## 创建一个项目

1. 安装cookiecutter

```sh
pip install -U cookiecutter
```


2. 通过此模板创建更美rpcd服务

```sh
cookiecutter git@e.coding.net:gengmei/tob/fastapi-rpcd-generator.git
```

```sh
project_name [gm-im (项目根目录、日志目录相同)]: gm-im
rpc_service_prefix [gm_im (rpc服务路由标识)]: gm_im
project_local_name [更美私信 (中文名字)]: 更美私信
first_app_name [message (第一个模块)]: message
settings_dir [gm_im (settings所在目录)]: gm_im
git_repo_url [https://gengmei.coding.net/p/tob/d/gm-im/git (git主页url)]: https://gengmei.coding.net/p/tob/d/gm-im/git 
```


## 测试启动项目

```
pyenv virtualenv 3.8.1 {{project_name}}
cd {{project_name}}
pip install -r requirements.txt

RPCD_SETTINGS_MODULE='{{settings_dir}}.settings' uvicorn fastapi_rpcd.asgi:application --port 8000 --reload
```

注意`curl`更改一下method

```sh
curl -X "POST" "http://127.0.0.1:8000/v1/batch" \
     -H 'Content-Type: application/x-www-form-urlencoded' \
     --data-urlencode "requests=[{\"method\":\"doris/echo\",\"params\":{},\"session_key\":null,\"environment\":{\"client_info\":null,\"l5d_path\":null,\"trace_context\":{\"trace_id\":\"3182b6a844c94f7f91bfdbe447e1e0f0\",\"span_id\":\"0.6\",\"sampled\":true,\"debug\":false}},\"timeout\":120}]"
```

