# -*- coding: utf-8 -*-
from utils.db.connector import database
from utils.redis import initialize_redis_pool, release_redis_pool


async def startup_database():
    await database.connect()


async def shutdown_database():
    await database.disconnect()


async def startup_redis_pool():
    await initialize_redis_pool()


async def shutdown_redis_pool():
    await release_redis_pool()


fastapi_on_startup = [startup_database, startup_redis_pool]
fastapi_on_shutdown = [shutdown_database, release_redis_pool]