# -*- coding: utf-8 -*-
from datetime import datetime
import time

from fastapi_rpcd.all import bind
from fastapi_rpcd.all import Context

from pydantic import BaseModel
from utils.db.connector import database

from fastapi_rpcd.all import Schema

import sentry_sdk



class ServiceNameResp(Schema):
    service_name: str



class TimeSelect1(Schema):
    process_time: float = None
    action: str = "Nameless"
    dt: datetime = None
    dt_str: str = None
    res_dt: datetime = None
    res_dt_str: str = None
    now: datetime = None


@bind('{{cookiecutter.rpc_service_prefix}}/demo/service_name')
async def service_name(ctx: Context, req: TimeSelect1) -> ServiceNameResp:
    """
        @api {get} {{cookiecutter.rpc_service_prefix}}/demo/service_name service_name
        @apiName service_name
        @apiGroup demo

        @apiSuccess {String} pims

        @apiSuccessExample {html} 响应data示例:
        pims

        @apiExample {curl} curl请求示例:
            curl -X "POST" "http://127.0.0.1:8000/v1/batch" \
     -H 'X-Gaia-Helios-Version: 0.1.2' \
     -H 'X-Gm-Request-Id: 123' \
     -H 'X-Gm-Path: /prod/{{cookiecutter.rpc_service_prefix}}' \
     -H 'X-Gm-Rpc-Method: {{cookiecutter.rpc_service_prefix}}/demo/service_name' \
     -H 'Content-Type: application/x-www-form-urlencoded; charset=utf-8' \
     --data-urlencode "requests=[{\"method\": \"{{cookiecutter.rpc_service_prefix}}/demo/service_name\", \"params\": {}, \"session_key\": \"b5zelj1tj99c74uo7q681ab7poawzwv8\", \"environment\": {\"client_info\": {\"gm_request_id\": \"123\"}, \"l5d_path\": \"\", \"device_id\": null, \"user_id\": null, \"metadata\": {}}, \"timeout\": 10}]"
    """
    print(req.action)
    resp = ServiceNameResp(**{'service_name': '{{cookiecutter.project_name}}'})

    sentry_sdk.capture_event({
        "method": "{{cookiecutter.rpc_service_prefix}}/demo/service_name",
        "params": {
            "orthwer":"dict_data"
        },
        "rt_ms": 1234,
    })

    return resp